| Flutter Impeller |

Public Member Functions | List of all members
impeller::ClipRestoreContents Class Referencefinal

`#include <clip_contents.h>`

Inheritance diagram for impeller::ClipRestoreContents:

## Public Member Functions
| ClipRestoreContents ()
| ~ClipRestoreContents ()
void | SetRestoreHeight (size_t clip_height)
size_t | GetRestoreHeight () const
void | SetRestoreCoverage (std::optional< Rect > coverage)
| The area on the pass texture where this clip restore will be applied. If unset, the entire pass texture will be restored. More...
std::optional< Rect > | GetCoverage (const Entity &entity) const override
| Get the area of the render pass that will be affected when this contents is rendered. More...
ClipCoverage | GetClipCoverage (const Entity &entity, const std::optional< Rect > &current_clip_coverage) const override
| Given the current pass space bounding rectangle of the clip buffer, return the expected clip coverage after this draw call. This should only be implemented for contents that may write to the clip buffer. More...
bool | ShouldRender (const Entity &entity, const std::optional< Rect > clip_coverage) const override
bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
bool | CanInheritOpacity (const Entity &entity) const override
| Whether or not this contents can accept the opacity peephole optimization. More...
void | SetInheritedOpacity (Scalar opacity) override
| Inherit the provided opacity. More...
Public Member Functions inherited from impeller::Contents
| Contents ()
virtual | ~Contents ()
virtual void | PopulateGlyphAtlas (const std::shared_ptr< LazyGlyphAtlas > &lazy_glyph_atlas, Scalar scale)
| Add any text data to the specified lazy atlas. The scale parameter must be used again later when drawing the text. More...
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual bool | IsOpaque () const
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
virtual std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, int32_t mip_count=1, const std::string &label="Snapshot") const
| Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...
virtual const FilterContents * | AsFilter () const
| Cast to a filter. Returns `nullptr` if this Contents is not a filter. More...
virtual bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc)
| If possible, applies a color filter to this contents inputs on the CPU. More...

## Additional Inherited Members
Public Types inherited from impeller::Contents
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>
Static Public Member Functions inherited from impeller::Contents
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)

## Detailed Description

Definition at line 59 of file clip_contents.h.

## Constructor & Destructor Documentation

## ◆ ClipRestoreContents()

impeller::ClipRestoreContents::ClipRestoreContents | ( |  | ) |
| default

## ◆ ~ClipRestoreContents()

impeller::ClipRestoreContents::~ClipRestoreContents | ( |  | ) |
| default

## Member Function Documentation

## ◆ CanInheritOpacity()

bool impeller::ClipRestoreContents::CanInheritOpacity | ( | const Entity & | entity | ) | const
| override virtual

Whether or not this contents can accept the opacity peephole optimization.

By default all contents return false. Contents are responsible for determining whether or not their own geometries intersect in a way that makes accepting opacity impossible. It is always safe to return false, especially if computing overlap would be computationally expensive.

Reimplemented from impeller::Contents.

Definition at line 224 of file clip_contents.cc.

224 {
225 return true;
226 }

## ◆ GetClipCoverage()

Contents::ClipCoverage impeller::ClipRestoreContents::GetClipCoverage | ( | const Entity & | entity,
|  | const std::optional< Rect > & | current_clip_coverage
| ) |  | const
| override virtual

Given the current pass space bounding rectangle of the clip buffer, return the expected clip coverage after this draw call. This should only be implemented for contents that may write to the clip buffer.

During rendering, coverage coordinates count pixels from the top left corner of the framebuffer.

Reimplemented from impeller::Contents.

Definition at line 212 of file clip_contents.cc.

214 {
215 return {.type = ClipCoverage::Type::kRestore, .coverage = std::nullopt};
216 }

References impeller::Contents::ClipCoverage::type.

## ◆ GetCoverage()

std::optional< Rect > impeller::ClipRestoreContents::GetCoverage | ( | const Entity & | entity | ) | const
| override virtual

Get the area of the render pass that will be affected when this contents is rendered.

During rendering, coverage coordinates count pixels from the top left corner of the framebuffer.

Returns
  The coverage rectangle. An `std::nullopt` result means that rendering this contents has no effect on the output color.

Implements impeller::Contents.

Definition at line 207 of file clip_contents.cc.

208 {
209 return std::nullopt;
210 };

## ◆ GetRestoreHeight()

size_t impeller::ClipRestoreContents::GetRestoreHeight | ( |  | ) | const

Definition at line 198 of file clip_contents.cc.

198 {
199 return restore_height_;
200 }

Referenced by impeller::EntityPassClipStack::ApplyClipState().

## ◆ Render()

bool impeller::ClipRestoreContents::Render | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| override virtual

Implements impeller::Contents.

Definition at line 230 of file clip_contents.cc.

232 {
233 using VS = ClipPipeline::VertexShader;
234
235 pass.SetCommandLabel("Restore Clip");
236 auto options = OptionsFromPass(pass);
237 options.blend_mode = BlendMode::kDestination;
238 options.stencil_mode =
239 ContentContextOptions::StencilMode::kOverdrawPreventionRestore;
240 options.primitive_type = PrimitiveType::kTriangleStrip;
241 pass.SetPipeline(renderer.GetClipPipeline(options));
242 pass.SetStencilReference(0);
243
244 // Create a rect that covers either the given restore area, or the whole
245 // render target texture.
246 auto ltrb =
247 restore_coverage_.value_or(Rect::MakeSize(pass.GetRenderTargetSize()))
248 .GetLTRB();
249 VertexBufferBuilder<VS::PerVertexData> vtx_builder;
250 vtx_builder.AddVertices({
251 {Point(ltrb[0], ltrb[1])},
252 {Point(ltrb[2], ltrb[1])},
253 {Point(ltrb[0], ltrb[3])},
254 {Point(ltrb[2], ltrb[3])},
255 });
256 pass.SetVertexBuffer(
257 vtx_builder.CreateVertexBuffer(renderer.GetTransientsBuffer()));
258
259 VS::FrameInfo info;
260 info.depth = GetShaderClipDepth(entity);
261 info.mvp = pass.GetOrthographicTransform();
262 VS::BindFrameInfo(pass, renderer.GetTransientsBuffer().EmplaceUniform(info));
263
264 return pass.Draw().ok();
265 }

References impeller::VertexBufferBuilder< VertexType_, IndexType_ >::AddVertices(), impeller::VertexBufferBuilder< VertexType_, IndexType_ >::CreateVertexBuffer(), impeller::RenderPass::Draw(), impeller::HostBuffer::EmplaceUniform(), impeller::ContentContext::GetClipPipeline(), impeller::RenderPass::GetOrthographicTransform(), impeller::RenderPass::GetRenderTargetSize(), impeller::GetShaderClipDepth(), impeller::ContentContext::GetTransientsBuffer(), impeller::kDestination, impeller::ContentContextOptions::kOverdrawPreventionRestore, impeller::kTriangleStrip, impeller::TRect< Scalar >::MakeSize(), impeller::OptionsFromPass(), impeller::RenderPass::SetCommandLabel(), impeller::RenderPass::SetPipeline(), impeller::RenderPass::SetStencilReference(), and impeller::RenderPass::SetVertexBuffer().

## ◆ SetInheritedOpacity()

void impeller::ClipRestoreContents::SetInheritedOpacity | ( | Scalar | opacity | ) |
| override virtual

Inherit the provided opacity.

       Use of this method is invalid if CanAcceptOpacity returns false.

Reimplemented from impeller::Contents.

Definition at line 228 of file clip_contents.cc.

228 {}

## ◆ SetRestoreCoverage()

void impeller::ClipRestoreContents::SetRestoreCoverage | ( | std::optional< Rect > | coverage | ) |

The area on the pass texture where this clip restore will be applied. If unset, the entire pass texture will be restored.

Note
  This rectangle is not transformed by the entity's transform.

Definition at line 202 of file clip_contents.cc.

203 {
204 restore_coverage_ = restore_coverage;
205 }

## ◆ SetRestoreHeight()

void impeller::ClipRestoreContents::SetRestoreHeight | ( | size_t | clip_height | ) |

Definition at line 194 of file clip_contents.cc.

194 {
195 restore_height_ = clip_height;
196 }

## ◆ ShouldRender()

bool impeller::ClipRestoreContents::ShouldRender | ( | const Entity & | entity,
|  | const std::optional< Rect > | clip_coverage
| ) |  | const
| override virtual

Reimplemented from impeller::Contents.

Definition at line 218 of file clip_contents.cc.

220 {
221 return true;
222 }

The documentation for this class was generated from the following files:

- impeller/entity/contents/clip_contents.h
- impeller/entity/contents/clip_contents.cc

impeller::OptionsFromPass
ContentContextOptions OptionsFromPass(const RenderPass &pass)
Definition: contents.cc:19
impeller::BlendMode::kDestination
@ kDestination
impeller::GetShaderClipDepth
static Scalar GetShaderClipDepth(const Entity &entity)
Definition: clip_contents.cc:18
impeller::VS
SolidFillVertexShader VS
Definition: stroke_path_geometry.cc:16
impeller::PrimitiveType::kTriangleStrip
@ kTriangleStrip
impeller::Point
TPoint< Scalar > Point
Definition: point.h:322
impeller::RenderPipelineHandle::VertexShader
VertexShader_ VertexShader
Definition: pipeline.h:106
impeller::TRect< Scalar >::MakeSize
constexpr static TRect MakeSize(const TSize< U > &size)
Definition: rect.h:146
impeller::ContentContextOptions::StencilMode::kOverdrawPreventionRestore
@ kOverdrawPreventionRestore